import .connectives
import .leibniz
import .logic
import .relations
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.S : (nat.nat) -> nat.nat.
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )).
theorem nat.eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.axiom_filter_nat_type_O) (return_type)) (return)).
theorem nat.sym_eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((return) ((nat.O) ))) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.eq_filter_nat_type_O) (return_type)) (return)).
axiom nat.axiom_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))).
theorem nat.eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.axiom_filter_nat_type_S) (return_type)) (return)) (n)).
theorem nat.sym_eq_filter_nat_type_S : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , forall (n:nat.nat) , (((leibniz.leibniz) (return_type)) ((return) (((nat.S) ) (n)))) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n))) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) (((nat.S) ) (n)))) ((return) (((nat.S) ) (n)))) ((((@nat.eq_filter_nat_type_S) (return_type)) (return)) (n)).
axiom nat.nat_ind : forall (Q:(nat.nat) -> Prop) , ((Q) ((nat.O) )) -> (forall (x:nat.nat) , ((Q) (x)) -> (Q) (((nat.S) ) (x))) -> forall (x:nat.nat) , (Q) (x).
constant nat.le_ : (nat.nat) -> (nat.nat) -> Prop.
axiom nat.le_n : forall (n:nat.nat) , (((nat.le_) ) (n)) (n).
axiom nat.le_S : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (((nat.le_) ) (n)) (((nat.S) ) (m)).
axiom nat.le_ind : forall (n:nat.nat) , forall (Q:(nat.nat) -> Prop) , ((Q) (n)) -> (forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> ((Q) (m)) -> (Q) (((nat.S) ) (m))) -> forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (Q) (m).
def nat.lt_ : (nat.nat) -> (nat.nat) -> Prop := fun (n : nat.nat) , fun (m : nat.nat) , (((nat.le_) ) (((nat.S) ) (n))) (m).
constant nat.plus : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.plus_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_plus : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)).
theorem nat.eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.axiom_plus) (n)).
theorem nat.sym_eq_plus : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) (((nat.plus) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (n))) ((@nat.eq_plus) (n)).
axiom nat.axiom_plus_body_O : (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m).
theorem nat.eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m) := ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.axiom_plus_body_O).
theorem nat.sym_eq_plus_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , m)) (((nat.plus_body) ) ((nat.O) )) := ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) ((nat.O) ))) (fun (m : nat.nat) , m)) (@nat.eq_plus_body_O).
axiom nat.axiom_plus_body_S : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m))).
theorem nat.eq_plus_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m))) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((@nat.axiom_plus_body_S) (n)).
theorem nat.sym_eq_plus_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) (((nat.plus_body) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.plus_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , ((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((@nat.eq_plus_body_S) (n)).
constant nat.times : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.times_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_times : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)).
theorem nat.eq_times : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) ((@nat.axiom_times) (n)).
theorem nat.sym_eq_times : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) (((nat.times) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) ((@nat.eq_times) (n)).
axiom nat.axiom_times_body_O : (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) ).
theorem nat.eq_times_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) ) := ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) )) (@nat.axiom_times_body_O).
theorem nat.sym_eq_times_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , (nat.O) )) (((nat.times_body) ) ((nat.O) )) := ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) )) (@nat.eq_times_body_O).
axiom nat.axiom_times_body_S : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m))).
theorem nat.eq_times_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m))) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((@nat.axiom_times_body_S) (n)).
theorem nat.sym_eq_times_body_S : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) (((nat.times_body) ) (((nat.S) ) (n))) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) (((nat.S) ) (n)))) (fun (m : nat.nat) , (((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((@nat.eq_times_body_S) (n)).
theorem nat.plus_O_n : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((((nat.plus) ) ((nat.O) )) (n)) := fun (n : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((y) (n)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((y) (n)))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((y) (n)))) (((@logic.refl_) (nat.nat)) (n)))).
theorem nat.plus_n_O : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) (n)) ((((nat.plus) ) (n)) ((nat.O) )) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((logic.eq_) (nat.nat)) (_x_365)) ((((nat.plus) ) (_x_365)) ((nat.O) )))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) ((nat.O) )))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) ((nat.O) )))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) ((nat.O) )))) (((@logic.refl_) (nat.nat)) ((nat.O) )))))) (fun (x_366 : nat.nat) , fun (_x_368 : (((logic.eq_) (nat.nat)) (x_366)) ((((nat.plus) ) (x_366)) ((nat.O) ))) , ((((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (x_366))) ((y) ((nat.O) )))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (x_366))) ((y) ((nat.O) )))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (x_366))) ((y) ((nat.O) )))) (((((((@logic.rewrite_l) (nat.nat)) (x_366)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (x_366))) (((nat.S) ) (__)))) (((@logic.refl_) (nat.nat)) (((nat.S) ) (x_366)))) ((((nat.plus) ) (x_366)) ((nat.O) ))) (_x_368))))))) (n).
theorem nat.plus_n_Sm : forall (n:nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (n)) (m)))) ((((nat.plus) ) (n)) (((nat.S) ) (m))) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (_x_365)) (m)))) ((((nat.plus) ) (_x_365)) (((nat.S) ) (m))))) (fun (m : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus) ) ((nat.O) )) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (m)))) ((y) (((nat.S) ) (m))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (m)))) ((y) (((nat.S) ) (m))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) ((nat.O) )) (((nat.S) ) (m))))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) ((nat.O) )) (((nat.S) ) (m))))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (m))) ((y) (((nat.S) ) (m))))) (((@logic.refl_) (nat.nat)) (((nat.S) ) (m)))))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (m:nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) (m)))) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))) , (fun (m : nat.nat) , (((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus) ) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) (m)))) ((y) (((nat.S) ) (m))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) (m)))) ((y) (((nat.S) ) (m))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((y) (m)))) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (((nat.S) ) ((((nat.plus) ) (x_366)) (m))))) ((y) (((nat.S) ) (m))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m)))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m))))) (__))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (((nat.S) ) (m)))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m))))) ((_x_368) (((nat.S) ) (m))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (((nat.S) ) (m))))) ((_x_368) (((nat.S) ) (m))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (m)))) ((_x_368) (m))))))))))) (n).
theorem nat.commutative_plus : ((relations.commutative) (nat.nat)) ((nat.plus) ) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (y:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (_x_365)) (y))) ((((nat.plus) ) (y)) (_x_365)))) (fun (y : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) ((nat.O) )))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) ((nat.O) )))) (((@nat.sym_eq_plus_body_O) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) ((nat.O) )))) (((((((@logic.rewrite_l) (nat.nat)) (y)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (y)) (__))) (((@logic.refl_) (nat.nat)) (y))) ((((nat.plus) ) (y)) ((nat.O) ))) ((@nat.plus_n_O) (y))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (y:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (y))) ((((nat.plus) ) (y)) (x_366))) , (fun (y : nat.nat) , (((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) (y)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) ((((nat.plus) ) (x_366)) (((nat.S) ) (y)))) (((((((@logic.rewrite_l) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) (y)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (y)) (x_366))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) ((((nat.plus) ) (y)) (((nat.S) ) (x_366))))) (((@nat.plus_n_Sm) (y)) (x_366))) ((((nat.plus) ) (x_366)) (y))) ((_x_368) (y)))) ((((nat.plus) ) (x_366)) (((nat.S) ) (y)))) (((@nat.plus_n_Sm) (x_366)) (y))))) (((nat.S) ) ((((nat.plus) ) (x_366)) (y)))) (((@nat.plus_n_Sm) (x_366)) (y)))))))) (n).
theorem nat.associative_plus : ((relations.associative) (nat.nat)) ((nat.plus) ) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (y:nat.nat) , forall (z:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) (_x_365)) (y))) (z))) ((((nat.plus) ) (_x_365)) ((((nat.plus) ) (y)) (z))))) (fun (y : nat.nat) , fun (z : nat.nat) , (((@nat.sym_eq_plus) ((nat.O) )) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) ((nat.O) )) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) ((((nat.plus) ) (y)) (z))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) ((((nat.plus) ) (y)) (z))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus_body) ) ((nat.O) )) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) (((@nat.sym_eq_plus_body_O) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus_body) ) ((nat.O) )) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) (((@nat.sym_eq_plus_body_O) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) ((((nat.plus) ) (y)) (z)))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (y)) (z)))))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (y:nat.nat) , forall (z:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) (x_366)) (y))) (z))) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))) , (fun (y : nat.nat) , fun (z : nat.nat) , (((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) (((nat.S) ) (x_366))) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) ((((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) ((((nat.plus) ) (y)) (z))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (x_366))) ((((nat.plus) ) (y)) (z))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((((nat.plus_body) ) (((nat.S) ) (x_366))) (y))) (z))) ((x) ((((nat.plus) ) (y)) (z))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((x) (y))) (z))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) ((((@nat.sym_eq_plus) (((nat.S) ) ((((nat.plus) ) (x_366)) (y)))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((x) (z))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((((nat.plus) ) (x_366)) (y))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((x) (z))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) ((((@nat.sym_eq_plus_body_S) ((((nat.plus) ) (x_366)) (y))) (fun (x : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((x) (z))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) (((@logic.refl_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (y)) (z)))))) ((((nat.plus) ) ((((nat.plus) ) (x_366)) (y))) (z))) (((_x_368) (y)) (z)))))))))))))) (n).
theorem nat.assoc_plus1 : forall (a:nat.nat) , forall (b:nat.nat) , forall (c:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (c)) ((((nat.plus) ) (b)) (a)))) ((((nat.plus) ) ((((nat.plus) ) (b)) (c))) (a)) := fun (a : nat.nat) , fun (b : nat.nat) , fun (c : nat.nat) , ((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (a)) (b))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (c)) (__))) ((((nat.plus) ) ((((nat.plus) ) (b)) (c))) (a)))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (a)) ((((nat.plus) ) (b)) (c)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (c)) ((((nat.plus) ) (a)) (b)))) (__))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (a)) ((((nat.plus) ) (b)) (c)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) ((((nat.plus) ) (a)) ((((nat.plus) ) (b)) (c))))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (a)) ((((nat.plus) ) (b)) (c))))) ((((nat.plus) ) (c)) ((((nat.plus) ) (a)) (b)))) (((((((@logic.rewrite_l) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) (a)) (b))) (c))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (c)) ((((nat.plus) ) (a)) (b)))) (__))) (((@nat.commutative_plus) (c)) ((((nat.plus) ) (a)) (b)))) ((((nat.plus) ) (a)) ((((nat.plus) ) (b)) (c)))) ((((@nat.associative_plus) (a)) (b)) (c))))) ((((nat.plus) ) ((((nat.plus) ) (b)) (c))) (a))) (((@nat.commutative_plus) ((((nat.plus) ) (b)) (c))) (a)))) ((((nat.plus) ) (b)) (a))) (((@nat.commutative_plus) (b)) (a)).
theorem nat.times_Sn_m : forall (n:nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((((nat.times) ) (((nat.S) ) (n))) (m)) := fun (n : nat.nat) , fun (m : nat.nat) , (((@nat.sym_eq_times) (((nat.S) ) (n))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((y) (m)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((y) (m)))) ((((@nat.sym_eq_times_body_S) (n)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))) ((y) (m)))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.times) ) (n)) (m)))))).
theorem nat.times_O_n : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.times) ) ((nat.O) )) (n)) := fun (n : nat.nat) , (((@nat.sym_eq_times) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) (n)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) (n)))) (((@nat.sym_eq_times_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) (n)))) (((@logic.refl_) (nat.nat)) ((nat.O) )))).
theorem nat.times_n_O : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.times) ) (n)) ((nat.O) )) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.times) ) (_x_365)) ((nat.O) )))) (((((((@logic.rewrite_l) (nat.nat)) ((nat.O) )) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) (__))) (((@logic.refl_) (nat.nat)) ((nat.O) ))) ((((nat.times) ) ((nat.O) )) ((nat.O) ))) ((@nat.times_O_n) ((nat.O) )))) (fun (x_366 : nat.nat) , fun (_x_368 : (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.times) ) (x_366)) ((nat.O) ))) , (((((((@logic.rewrite_l) (nat.nat)) ((((nat.plus) ) ((nat.O) )) ((((nat.times) ) (x_366)) ((nat.O) )))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) (__))) (((((((@logic.rewrite_l) (nat.nat)) ((nat.O) )) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.plus) ) ((nat.O) )) (__)))) (((((((@logic.rewrite_l) (nat.nat)) ((nat.O) )) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) (__))) (((@logic.refl_) (nat.nat)) ((nat.O) ))) ((((nat.plus) ) ((nat.O) )) ((nat.O) ))) ((@nat.plus_O_n) ((nat.O) )))) ((((nat.times) ) (x_366)) ((nat.O) ))) (_x_368))) ((((nat.times) ) (((nat.S) ) (x_366))) ((nat.O) ))) (((@nat.times_Sn_m) (x_366)) ((nat.O) ))))) (n).
theorem nat.times_n_Sm : forall (n:nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (n)) ((((nat.times) ) (n)) (m)))) ((((nat.times) ) (n)) (((nat.S) ) (m))) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (_x_365)) ((((nat.times) ) (_x_365)) (m)))) ((((nat.times) ) (_x_365)) (((nat.S) ) (m))))) ((((@nat.sym_eq_times) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((nat.O) )) ((((nat.times) ) ((nat.O) )) (m)))) ((y) (((nat.S) ) (m))))) ((((@nat.sym_eq_times) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((nat.O) )) ((y) (m)))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) ((nat.O) )) (((nat.S) ) (m))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (fun (y : (nat.nat) -> nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((nat.O) )) ((y) (m)))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) ((nat.O) )) (((nat.S) ) (m))))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (fun (y : (nat.nat) -> nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((nat.O) )) ((((nat.times_body) ) ((nat.O) )) (m)))) ((y) (((nat.S) ) (m))))) (((@nat.sym_eq_times_body_O) (fun (y : (nat.nat) -> nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((nat.O) )) ((((nat.times_body) ) ((nat.O) )) (m)))) ((y) (((nat.S) ) (m))))) (((@nat.sym_eq_times_body_O) (fun (y : (nat.nat) -> nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) ((nat.O) )) ((y) (m)))) ((nat.O) ))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((y) ((nat.O) ))) ((nat.O) ))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((y) ((nat.O) ))) ((nat.O) ))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((y) ((nat.O) ))) ((nat.O) ))) (fun (_m : nat.nat) , ((@logic.refl_) (nat.nat)) ((nat.O) )))))))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (m:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.times) ) (x_366)) (m)))) ((((nat.times) ) (x_366)) (((nat.S) ) (m)))) , (fun (m : nat.nat) , (((@nat.sym_eq_times) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (((nat.S) ) (x_366))) ((((nat.times) ) (((nat.S) ) (x_366))) (m)))) ((y) (((nat.S) ) (m))))) ((((@nat.sym_eq_times) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (((nat.S) ) (x_366))) ((y) (m)))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (((nat.S) ) (x_366))) ((y) (m)))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (((nat.S) ) (x_366))) (((nat.S) ) (m))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (((nat.S) ) (x_366))) ((((nat.times_body) ) (((nat.S) ) (x_366))) (m)))) ((y) (((nat.S) ) (m))))) ((((@nat.sym_eq_times_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (((nat.S) ) (x_366))) ((((nat.times_body) ) (((nat.S) ) (x_366))) (m)))) ((y) (((nat.S) ) (m))))) ((((@nat.sym_eq_times_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (((nat.S) ) (x_366))) ((y) (m)))) ((((nat.plus) ) (((nat.S) ) (m))) ((((nat.times) ) (x_366)) (((nat.S) ) (m)))))) ((((@nat.sym_eq_plus) (((nat.S) ) (x_366))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((y) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m))))) ((((nat.plus) ) (((nat.S) ) (m))) ((((nat.times) ) (x_366)) (((nat.S) ) (m)))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((y) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m))))) ((((nat.plus) ) (((nat.S) ) (m))) ((((nat.times) ) (x_366)) (((nat.S) ) (m)))))) ((((@nat.sym_eq_plus_body_S) (x_366)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((y) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m))))) ((((nat.plus) ) (((nat.S) ) (m))) ((((nat.times) ) (x_366)) (((nat.S) ) (m)))))) ((((@nat.sym_eq_plus) (((nat.S) ) (m))) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m)))))) ((y) ((((nat.times) ) (x_366)) (((nat.S) ) (m)))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (m)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m)))))) ((y) ((((nat.times) ) (x_366)) (((nat.S) ) (m)))))) ((((@nat.sym_eq_plus_body_S) (m)) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m)))))) ((y) ((((nat.times) ) (x_366)) (((nat.S) ) (m)))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m)))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (((nat.S) ) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (((nat.S) ) (m))))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (m)) (((nat.S) ) ((((nat.times) ) (x_366)) (m))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) (__))) (((nat.S) ) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (((nat.S) ) (m))))))) (((((((@logic.rewrite_l) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.times) ) (x_366)) (m)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) (((nat.S) ) ((((nat.times) ) (x_366)) (m)))))) (((nat.S) ) ((((nat.plus) ) (m)) (__))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) (((nat.S) ) ((((nat.times) ) (x_366)) (m)))))) (((nat.S) ) (__)))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (x_366)) (((nat.S) ) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m)))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) (((nat.S) ) ((((nat.times) ) (x_366)) (m)))))) (__))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (m)) (((nat.S) ) ((((nat.times) ) (x_366)) (m))))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) (((nat.S) ) ((((nat.times) ) (x_366)) (m)))))) ((((nat.plus) ) (x_366)) (__)))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) (((nat.S) ) ((((nat.times) ) (x_366)) (m))))))) (((nat.S) ) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m))))) (((@nat.plus_n_Sm) (m)) ((((nat.times) ) (x_366)) (m))))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m)))))) (((@nat.plus_n_Sm) (x_366)) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m)))))) ((((nat.plus) ) (m)) ((((nat.plus) ) (x_366)) ((((nat.times) ) (x_366)) (m))))) (((((((@logic.rewrite_l) (nat.nat)) ((((nat.plus) ) ((((nat.plus) ) (x_366)) (m))) ((((nat.times) ) (x_366)) (m)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (m)) ((((nat.plus) ) (x_366)) ((((nat.times) ) (x_366)) (m))))) (__))) ((((@nat.assoc_plus1) ((((nat.times) ) (x_366)) (m))) (x_366)) (m))) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m))))) ((((@nat.associative_plus) (x_366)) (m)) ((((nat.times) ) (x_366)) (m)))))) ((((nat.times) ) (x_366)) (((nat.S) ) (m)))) ((_x_368) (m)))) (((nat.S) ) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m))))) (((@nat.plus_n_Sm) (m)) ((((nat.times) ) (x_366)) (m))))) (((nat.S) ) ((((nat.plus) ) (x_366)) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m)))))) (((@nat.plus_n_Sm) (x_366)) ((((nat.plus) ) (m)) ((((nat.times) ) (x_366)) (m))))))))))))))))))) (n).
theorem nat.commutative_times : ((relations.commutative) (nat.nat)) ((nat.times) ) := fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (y:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.times) ) (_x_365)) (y))) ((((nat.times) ) (y)) (_x_365)))) ((((@nat.sym_eq_times) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , forall (z:nat.nat) , (((logic.eq_) (nat.nat)) ((y) (z))) ((((nat.times) ) (z)) ((nat.O) )))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (fun (y : (nat.nat) -> nat.nat) , forall (z:nat.nat) , (((logic.eq_) (nat.nat)) ((y) (z))) ((((nat.times) ) (z)) ((nat.O) )))) (((@nat.sym_eq_times_body_O) (fun (y : (nat.nat) -> nat.nat) , forall (z:nat.nat) , (((logic.eq_) (nat.nat)) ((y) (z))) ((((nat.times) ) (z)) ((nat.O) )))) (fun (y : nat.nat) , ((((((@logic.rewrite_l) (nat.nat)) ((nat.O) )) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) (__))) (((@logic.refl_) (nat.nat)) ((nat.O) ))) ((((nat.times) ) (y)) ((nat.O) ))) ((@nat.times_n_O) (y))))))) (fun (x_366 : nat.nat) , fun (_x_368 : forall (y:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.times) ) (x_366)) (y))) ((((nat.times) ) (y)) (x_366))) , (fun (y : nat.nat) , (((@nat.sym_eq_times) (((nat.S) ) (x_366))) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.times) ) (y)) (((nat.S) ) (x_366))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (x_366)) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.times) ) (y)) (((nat.S) ) (x_366))))) ((((@nat.sym_eq_times_body_S) (x_366)) (fun (z : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((z) (y))) ((((nat.times) ) (y)) (((nat.S) ) (x_366))))) (((((((@logic.rewrite_l) (nat.nat)) ((((nat.plus) ) (y)) ((((nat.times) ) (y)) (x_366)))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (y)) ((((nat.times) ) (x_366)) (y)))) (__))) (((((((@logic.rewrite_l) (nat.nat)) ((((nat.times) ) (x_366)) (y))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.plus) ) (y)) ((((nat.times) ) (x_366)) (y)))) ((((nat.plus) ) (y)) (__)))) (((@logic.refl_) (nat.nat)) ((((nat.plus) ) (y)) ((((nat.times) ) (x_366)) (y))))) ((((nat.times) ) (y)) (x_366))) ((_x_368) (y)))) ((((nat.times) ) (y)) (((nat.S) ) (x_366)))) (((@nat.times_n_Sm) (y)) (x_366)))))))) (n).
theorem nat.le_S_S : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m)) := fun (n : nat.nat) , fun (m : nat.nat) , fun (lenm : (((nat.le_) ) (n)) (m)) , (((((((@nat.le_ind) (n)) (fun (x_417 : nat.nat) , (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (x_417)))) ((@nat.le_n) (((nat.S) ) (n)))) (fun (m0 : nat.nat) , fun (_x_419 : (((nat.le_) ) (n)) (m0)) , (fun (_x_421 : (((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (m0))) , ((((@nat.le_S) (((nat.S) ) (n))) (((nat.S) ) (m0))) (_x_421))))) (m)) (lenm)).
theorem nat.le_O_n : forall (n:nat.nat) , (((nat.le_) ) ((nat.O) )) (n) := fun (n : nat.nat) , ((((@nat.nat_ind) (((nat.le_) ) ((nat.O) ))) ((@nat.le_n) ((nat.O) ))) (fun (x_366 : nat.nat) , fun (_x_368 : (((nat.le_) ) ((nat.O) )) (x_366)) , ((((@nat.le_S) ((nat.O) )) (x_366)) (_x_368)))) (n).
theorem nat.transitive_le : ((relations.transitive) (nat.nat)) ((nat.le_) ) := fun (a : nat.nat) , fun (b : nat.nat) , fun (c : nat.nat) , fun (leab : (((nat.le_) ) (a)) (b)) , (fun (lebc : (((nat.le_) ) (b)) (c)) , (((((((@nat.le_ind) (b)) (fun (x_417 : nat.nat) , (((nat.le_) ) (a)) (x_417))) (leab)) (fun (m : nat.nat) , fun (_x_419 : (((nat.le_) ) (b)) (m)) , (fun (_x_421 : (((nat.le_) ) (a)) (m)) , ((((@nat.le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
theorem nat.monotonic_le_plus_r : forall (n:nat.nat) , (((relations.monotonic) (nat.nat)) ((nat.le_) )) (fun (m : nat.nat) , (((nat.plus) ) (n)) (m)) := fun (n : nat.nat) , fun (a : nat.nat) , fun (b : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus) ) (_x_365)) (a))) ((((nat.plus) ) (_x_365)) (b)))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus) ) ((nat.O) )) (a))) ((y) (b)))) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((y) (a))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (b)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((y) (a))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) ((nat.O) )) (b)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus_body) ) ((nat.O) )) (a))) ((y) (b)))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus_body) ) ((nat.O) )) (a))) ((y) (b)))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((y) (a))) (b))) (fun (auto : (((nat.le_) ) (a)) (b)) , (auto))))))))) (fun (m : nat.nat) , fun (H : ((((nat.le_) ) (a)) (b)) -> (((nat.le_) ) ((((nat.plus) ) (m)) (a))) ((((nat.plus) ) (m)) (b))) , (fun (leab : (((nat.le_) ) (a)) (b)) , ((((@nat.sym_eq_plus) (((nat.S) ) (m))) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.plus) ) (((nat.S) ) (m))) (a))) ((y) (b)))) ((((@nat.sym_eq_plus) (((nat.S) ) (m))) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((y) (a))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (m))) (b)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (m)) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((y) (a))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (((nat.S) ) (m))) (b)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (m)) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.plus_body) ) (((nat.S) ) (m))) (a))) ((y) (b)))) ((((@nat.sym_eq_plus_body_S) (m)) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.plus_body) ) (((nat.S) ) (m))) (a))) ((y) (b)))) ((((@nat.sym_eq_plus_body_S) (m)) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) ((y) (a))) (((nat.S) ) ((((nat.plus) ) (m)) (b))))) ((((@nat.le_S_S) ((((nat.plus) ) (m)) (a))) ((((nat.plus) ) (m)) (b))) ((H) (leab)))))))))))) (n).
theorem nat.monotonic_le_plus_l : forall (m:nat.nat) , (((relations.monotonic) (nat.nat)) ((nat.le_) )) (fun (n : nat.nat) , (((nat.plus) ) (n)) (m)) := fun (m : nat.nat) , fun (x : nat.nat) , fun (y : nat.nat) , fun (auto : (((nat.le_) ) (x)) (y)) , (((((@logic.eq_coerc) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) ((((nat.plus) ) (m)) (y)))) ((((nat.le_) ) ((((nat.plus) ) (x)) (m))) ((((nat.plus) ) (y)) (m)))) (((((@nat.monotonic_le_plus_r) (m)) (x)) (y)) (auto))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (m)) (x))) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) ((((nat.plus) ) (m)) (y)))) ((((nat.le_) ) (__)) ((((nat.plus) ) (y)) (m))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (m)) (y))) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) ((((nat.plus) ) (m)) (y)))) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) (__)))) (((@logic.refl_) (Prop)) ((((nat.le_) ) ((((nat.plus) ) (m)) (x))) ((((nat.plus) ) (m)) (y))))) ((((nat.plus) ) (y)) (m))) (((@nat.commutative_plus) (y)) (m)))) ((((nat.plus) ) (x)) (m))) (((@nat.commutative_plus) (x)) (m)))).
theorem nat.le_plus : forall (n1:nat.nat) , forall (n2:nat.nat) , forall (m1:nat.nat) , forall (m2:nat.nat) , ((((nat.le_) ) (n1)) (n2)) -> ((((nat.le_) ) (m1)) (m2)) -> (((nat.le_) ) ((((nat.plus) ) (n1)) (m1))) ((((nat.plus) ) (n2)) (m2)) := fun (n1 : nat.nat) , fun (n2 : nat.nat) , fun (m1 : nat.nat) , fun (m2 : nat.nat) , fun (len : (((nat.le_) ) (n1)) (n2)) , (fun (lem : (((nat.le_) ) (m1)) (m2)) , ((((((@nat.transitive_le) ((((nat.plus) ) (n1)) (m1))) ((((nat.plus) ) (n1)) (m2))) ((((nat.plus) ) (n2)) (m2))) (((((@nat.monotonic_le_plus_r) (n1)) (m1)) (m2)) (lem))) (((((@nat.monotonic_le_plus_l) (m2)) (n1)) (n2)) (len)))).
theorem nat.le_plus_n : forall (n:nat.nat) , forall (m:nat.nat) , (((nat.le_) ) (m)) ((((nat.plus) ) (n)) (m)) := fun (n : nat.nat) , fun (m : nat.nat) , ((((@logic.eq_coerc) ((((nat.le_) ) ((((nat.plus) ) ((nat.O) )) (m))) ((((nat.plus) ) (n)) (m)))) ((((nat.le_) ) (m)) ((((nat.plus) ) (n)) (m)))) (((((@nat.monotonic_le_plus_l) (m)) ((nat.O) )) (n)) ((@nat.le_O_n) (n)))) (((((((@logic.rewrite_l) (nat.nat)) (m)) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (__)) ((((nat.plus) ) (n)) (m)))) ((((nat.le_) ) (m)) ((((nat.plus) ) (n)) (m))))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (m)) ((((nat.plus) ) (n)) (m))))) ((((nat.plus) ) ((nat.O) )) (m))) ((@nat.plus_O_n) (m))).
theorem nat.monotonic_le_times_r : forall (n:nat.nat) , (((relations.monotonic) (nat.nat)) ((nat.le_) )) (fun (m : nat.nat) , (((nat.times) ) (n)) (m)) := fun (n : nat.nat) , fun (x : nat.nat) , fun (y : nat.nat) , fun (lexy : (((nat.le_) ) (x)) (y)) , (((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((nat.le_) ) ((((nat.times) ) (_x_365)) (x))) ((((nat.times) ) (_x_365)) (y)))) ((((@nat.sym_eq_times) ((nat.O) )) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.times) ) ((nat.O) )) (x))) ((z) (y)))) ((((@nat.sym_eq_times) ((nat.O) )) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((z) (x))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) ((nat.O) )) (y)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((z) (x))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) ((nat.O) )) (y)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.times_body) ) ((nat.O) )) (x))) ((z) (y)))) (((@nat.sym_eq_times_body_O) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.times_body) ) ((nat.O) )) (x))) ((z) (y)))) (((@nat.sym_eq_times_body_O) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((z) (x))) ((nat.O) ))) ((@nat.le_O_n) ((nat.O) ))))))))) (fun (a : nat.nat) , fun (lea : (((nat.le_) ) ((((nat.times) ) (a)) (x))) ((((nat.times) ) (a)) (y))) , ((((@nat.sym_eq_times) (((nat.S) ) (a))) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.times) ) (((nat.S) ) (a))) (x))) ((z) (y)))) ((((@nat.sym_eq_times) (((nat.S) ) (a))) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((z) (x))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (((nat.S) ) (a))) (y)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (a)) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((z) (x))) (((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (((nat.S) ) (a))) (y)))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (a)) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.times_body) ) (((nat.S) ) (a))) (x))) ((z) (y)))) ((((@nat.sym_eq_times_body_S) (a)) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((((nat.times_body) ) (((nat.S) ) (a))) (x))) ((z) (y)))) ((((@nat.sym_eq_times_body_S) (a)) (fun (z : (nat.nat) -> nat.nat) , (((nat.le_) ) ((z) (x))) ((((nat.plus) ) (y)) ((((nat.times) ) (a)) (y))))) (((((((@nat.le_plus) (x)) (y)) ((((nat.times) ) (a)) (x))) ((((nat.times) ) (a)) (y))) (lexy)) (lea)))))))))) (n)).
theorem nat.le_times : forall (n1:nat.nat) , forall (n2:nat.nat) , forall (m1:nat.nat) , forall (m2:nat.nat) , ((((nat.le_) ) (n1)) (n2)) -> ((((nat.le_) ) (m1)) (m2)) -> (((nat.le_) ) ((((nat.times) ) (n1)) (m1))) ((((nat.times) ) (n2)) (m2)) := fun (n1 : nat.nat) , fun (n2 : nat.nat) , fun (m1 : nat.nat) , fun (m2 : nat.nat) , fun (len : (((nat.le_) ) (n1)) (n2)) , (fun (lem : (((nat.le_) ) (m1)) (m2)) , ((((((@nat.transitive_le) ((((nat.times) ) (n1)) (m1))) ((((nat.times) ) (n1)) (m2))) ((((nat.times) ) (n2)) (m2))) (((((@nat.monotonic_le_times_r) (n1)) (m1)) (m2)) (lem))) (((((@logic.eq_coerc) ((((nat.le_) ) ((((nat.times) ) (m2)) (n1))) ((((nat.times) ) (m2)) (n2)))) ((((nat.le_) ) ((((nat.times) ) (n1)) (m2))) ((((nat.times) ) (n2)) (m2)))) (((((@nat.monotonic_le_times_r) (m2)) (n1)) (n2)) (len))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.times) ) (n1)) (m2))) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (__)) ((((nat.times) ) (m2)) (n2)))) ((((nat.le_) ) ((((nat.times) ) (n1)) (m2))) ((((nat.times) ) (n2)) (m2))))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.times) ) (n2)) (m2))) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) ((((nat.times) ) (n1)) (m2))) (__))) ((((nat.le_) ) ((((nat.times) ) (n1)) (m2))) ((((nat.times) ) (n2)) (m2))))) (((@logic.refl_) (Prop)) ((((nat.le_) ) ((((nat.times) ) (n1)) (m2))) ((((nat.times) ) (n2)) (m2))))) ((((nat.times) ) (m2)) (n2))) (((@nat.commutative_times) (m2)) (n2)))) ((((nat.times) ) (m2)) (n1))) (((@nat.commutative_times) (m2)) (n1)))))).
theorem nat.transitive_lt : ((relations.transitive) (nat.nat)) ((nat.lt_) ) := fun (a : nat.nat) , fun (b : nat.nat) , fun (c : nat.nat) , fun (ltab : (((nat.lt_) ) (a)) (b)) , (fun (ltbc : (((nat.lt_) ) (b)) (c)) , (((((((@nat.le_ind) (((nat.S) ) (b))) (fun (x_417 : nat.nat) , (((nat.lt_) ) (a)) (x_417))) ((((@nat.le_S) (((nat.S) ) (a))) (b)) (ltab))) (fun (m : nat.nat) , fun (_x_419 : (((nat.le_) ) (((nat.S) ) (b))) (m)) , (fun (_x_421 : (((nat.lt_) ) (a)) (m)) , ((((@nat.le_S) (((nat.S) ) (a))) (m)) (_x_421))))) (c)) (ltbc))).
theorem nat.lt_to_le_to_lt : forall (n:nat.nat) , forall (m:nat.nat) , forall (p:nat.nat) , ((((nat.lt_) ) (n)) (m)) -> ((((nat.le_) ) (m)) (p)) -> (((nat.lt_) ) (n)) (p) := fun (n : nat.nat) , fun (m : nat.nat) , fun (p : nat.nat) , fun (H : (((nat.lt_) ) (n)) (m)) , (fun (H1 : (((nat.le_) ) (m)) (p)) , (((((((@nat.le_ind) (m)) (fun (x_417 : nat.nat) , (((nat.lt_) ) (n)) (x_417))) (H)) (fun (m0 : nat.nat) , fun (_x_419 : (((nat.le_) ) (m)) (m0)) , (fun (_x_421 : (((nat.lt_) ) (n)) (m0)) , ((((((@nat.transitive_lt) (n)) (m0)) (((nat.S) ) (m0))) (_x_421)) (((((@logic.eq_coerc) ((((nat.le_) ) (((nat.S) ) (m0))) ((((nat.plus) ) ((nat.O) )) (((nat.S) ) (m0))))) ((((nat.le_) ) (((nat.S) ) (m0))) (((nat.S) ) (m0)))) (((@nat.le_plus_n) ((nat.O) )) (((nat.S) ) (m0)))) (((((((@logic.rewrite_l) (nat.nat)) (((nat.S) ) (m0))) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (((nat.S) ) (m0))) (__))) ((((nat.le_) ) (((nat.S) ) (m0))) (((nat.S) ) (m0))))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (((nat.S) ) (m0))) (((nat.S) ) (m0))))) ((((nat.plus) ) ((nat.O) )) (((nat.S) ) (m0)))) ((@nat.plus_O_n) (((nat.S) ) (m0))))))))) (p)) (H1))).
theorem nat.ltn_to_ltO : forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.lt_) ) (n)) (m)) -> (((nat.lt_) ) ((nat.O) )) (m) := fun (n : nat.nat) , fun (m : nat.nat) , fun (auto : (((nat.lt_) ) (n)) (m)) , ((((((@nat.lt_to_le_to_lt) ((nat.O) )) (((nat.S) ) (n))) (m)) (((((@logic.eq_coerc) ((((nat.le_) ) (((nat.S) ) ((nat.O) ))) ((((nat.plus) ) (n)) (((nat.S) ) ((nat.O) ))))) ((((nat.le_) ) (((nat.S) ) ((nat.O) ))) (((nat.S) ) (n)))) (((@nat.le_plus_n) (n)) (((nat.S) ) ((nat.O) )))) (((((((@logic.rewrite_l) (nat.nat)) (((nat.S) ) (n))) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (((nat.S) ) ((nat.O) ))) (__))) ((((nat.le_) ) (((nat.S) ) ((nat.O) ))) (((nat.S) ) (n))))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (((nat.S) ) ((nat.O) ))) (((nat.S) ) (n))))) ((((nat.plus) ) (n)) (((nat.S) ) ((nat.O) )))) (((((((@logic.rewrite_r) (nat.nat)) ((((nat.plus) ) (n)) ((nat.O) ))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (__))) ((((nat.plus) ) (n)) (((nat.S) ) ((nat.O) ))))) (((@nat.plus_n_Sm) (n)) ((nat.O) ))) (n)) ((@nat.plus_n_O) (n)))))) (auto)).
theorem nat.lt_O_S : forall (n:nat.nat) , (((nat.lt_) ) ((nat.O) )) (((nat.S) ) (n)) := fun (n : nat.nat) , (((@nat.ltn_to_ltO) (n)) (((nat.S) ) (n))) (((((@logic.eq_coerc) ((((nat.le_) ) (((nat.S) ) (n))) ((((nat.plus) ) ((nat.O) )) (((nat.S) ) (n))))) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (n)))) (((@nat.le_plus_n) ((nat.O) )) (((nat.S) ) (n)))) (((((((@logic.rewrite_l) (nat.nat)) (((nat.S) ) (n))) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (((nat.S) ) (n))) (__))) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (n))))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (((nat.S) ) (n))) (((nat.S) ) (n))))) ((((nat.plus) ) ((nat.O) )) (((nat.S) ) (n)))) ((@nat.plus_O_n) (((nat.S) ) (n))))).
